#ifndef NOKIA6100DRIVER_H
#define NOKIA6100DRIVER_H

#define	PHILLIPS
//#define	EPSON

#include "Compiler.h"
#include "GenericTypeDefs.h"

//********************************************************************
//
//				General Function Definitions
//
//********************************************************************
void LCDCommand(unsigned char data);
void LCDData(unsigned char data);
void LCDInit(void);
void LCDClear(int color);
void LCDSetPixel(int color, unsigned char x, unsigned char y);
void LCDPrintLogo(void);
void LCDPrintString(const char *txt, int variable, int text_color, char row, char column, char inverted);
void LCDContrast(char setting);
unsigned char LCDPrintChar(char txt, int text_color, char *x_pos, char *y_pos, char inverted);
void drawLine(int color, int x0, int y0, int x1, int y1);
void drawHorizontalLine(BYTE color, BYTE x0, BYTE y0, BYTE x1);
void drawBox(BYTE color, BYTE x0, BYTE y0, BYTE x1, BYTE y1, BYTE BorderWeight);
void drawCircle(int color, int x0, int y0, int radius);
void drawFilledCircle(BYTE color, BYTE x0, BYTE y0, BYTE radius);
void drawFilledBox(BYTE color, BYTE x0, BYTE y0, BYTE x1, BYTE y1);
void LCDSetBoundries(BYTE x0, BYTE y0, BYTE x1, BYTE y1);
void LCDString(int Color, int FillColor, char * DisplayString, BYTE x, BYTE y);



typedef union _MADCTLOptions {
	BYTE MADCTLByte;
	struct _bits {
		unsigned X3:1;
		unsigned X2:1;
		unsigned X1:1;
		unsigned RGB:1;
		unsigned LAO:1;
		unsigned V:1;
		unsigned MX:1;
     	unsigned MY:1;  
 	} bits;    
} MADCTLOptions;



//*******************************************************
//					GPIO Definitions
//*******************************************************
#define LCD_RES LATCbits.LATC0
#define LCD_CS	LATCbits.LATC1
#define LCD_DIO LATAbits.LATA6
#define LCD_SCK LATAbits.LATA7

#define LCD_RES_TRIS TRISCbits.TRISC0
#define LCD_CS_TRIS TRISCbits.TRISC1
#define LCD_DIO_TRIS TRISAbits.TRISA6
#define LCD_SCK_TRIS TRISAbits.TRISA7

//********************************************************************
//
//					LCD Dimension Definitions
//
//********************************************************************
#define ROW_LENGTH	132
#define COL_HEIGHT	132
#define ENDPAGE     132
#define ENDCOL      130

//********************************************************************
//
//					EPSON Controller Definitions
//
//********************************************************************
#define DISON       0xAF
#define DISOFF      0xAE
#define DISNOR      0xA6
#define DISINV      0xA7
#define SLPIN       0x95
#define SLPOUT      0x94
#define COMSCN      0xBB
#define DISCTL      0xCA
#define PASET       0x75
#define CASET       0x15
#define DATCTL      0xBC
#define RGBSET8     0xCE
#define RAMWR       0x5C
#define RAMRD       0x5D
#define PTLIN       0xA8
#define PTLOUT      0xA9
#define RMWIN       0xE0
#define RMWOUT      0xEE
#define ASCSET      0xAA
#define SCSTART     0xAB
#define OSCON       0xD1
#define OSCOFF      0xD2
#define PWRCTR      0x20
#define VOLCTR      0x81
#define VOLUP       0xD6
#define VOLDOWN     0xD7
#define TMPGRD      0x82
#define EPCTIN      0xCD
#define EPCOUT      0xCC
#define EPMWR       0xFC
#define EPMRD       0xFD
#define EPSRRD1     0x7C
#define EPSRRD2     0x7D
#define NOP         0x25

//********************************************************************
//
//			PHILLIPS Controller Definitions
//
//********************************************************************
//LCD Commands
#define	NOPP		0x00
#define	BSTRON		0x03
#define SLEEPIN     0x10
#define	SLEEPOUT	0x11
#define	NORON		0x13
#define	INVOFF		0x20
#define INVON      	0x21
#define	SETCON		0x25
#define DISPOFF     0x28
#define DISPON      0x29
#define CASETP      0x2A
#define PASETP      0x2B
#define RAMWRP      0x2C
#define RGBSET	    0x2D
#define	MADCTL		0x36
#define	COLMOD		0x3A
#define DISCTR      0xB9
#define	EC			0xC0
#define DORSWAP		0xBB

//*******************************************************
//				8-Bit Color Definitions
//*******************************************************
#define WHITE	0xFF
#define BLACK	0x00
#define RED		(0b11100000)
#define	GREEN	(0b00011100)
#define	DARKGREEN	(0b00011000)
#define BLUE	(0b00000011)
#define CYAN	(GREEN | BLUE)
#define MAGENTA	(0b01000001)
#define YELLOW	(RED | GREEN)
#define BROWN	(0b00000010)
#define ORANGE	(0b11110000)
#define PINK	(RED | BLUE)
#define GREY	 (0b10110110)
#define DARKGREY (0b01001001)

#endif